/// @desc Set up 3D

//Set up camera values
z = 0;
x_to = 0;
y_to = 0;
z_to = 0;
y = 0;
x_rotation = 0;
z_rotation = 270;
rotation_speed = 2;
distance = 3;

draw_light_get_ambient()

//Set up the screen
render_width = 1024;
render_height = 1024;

//Set up the shaders
oneHorizontalUniform = shader_get_uniform(outline_shader,"oneHorizontal");
oneVerticalUniform = shader_get_uniform(outline_shader,"oneVertical");

//Surfaces to draw to
outline_mask = -1;
color_mask = -1;

//Showing the fps
last_fps = fps_real;

//Set up the vertex format
globalvar MODEL_VERTEX_FORMAT;
vertex_format_begin();
vertex_format_add_position_3d();
vertex_format_add_texcoord();
vertex_format_add_normal();
vertex_format_add_color();
MODEL_VERTEX_FORMAT = vertex_format_end();

//Create the model
model_to_create = model_to_view;
model = instance_create_depth(0,0,33,model_to_create);
model.x = 0;
model.y = 0;

//Settings for 3d stuff
gpu_set_ztestenable(true);
gpu_set_zwriteenable(true);
surface_depth_disable(false);
gpu_set_cullmode(cull_noculling);
gpu_set_tex_filter(true);

//Disable the application surface
application_surface_draw_enable(false);
application_surface_enable(false);

//Set up the camera
globalvar MAIN_CAMERA;
MAIN_CAMERA = self;
view_enabled = true;
view_distance = 10;
view_set_visible(0,true);
camera = camera_create();
projection_matrix = matrix_build_projection_perspective_fov(45,render_width/render_height,1,view_distance);
view_matrix = matrix_build_identity();
camera_set_proj_mat(MAIN_CAMERA.camera, MAIN_CAMERA.projection_matrix);
view_set_camera(0,MAIN_CAMERA.camera);
camera_set_update_script(MAIN_CAMERA.camera,camera_update);

//Anti aliasing
display_reset(8,false);

//Set up light
lightDirectionUniform = shader_get_uniform(toon_shader,"lightDirection");