/// @desc Draw the surfaces

//Draw the background
draw_sprite(backgroundSprite,0,0,0);

//Draw the color mask
if (surface_exists(MAIN_CAMERA.color_mask))
{
	draw_surface(MAIN_CAMERA.color_mask,0,0);
	//Clear it after drawing it
	surface_set_target(MAIN_CAMERA.color_mask);
		draw_clear_alpha(c_white,0);
	surface_reset_target();	
}
else
{
	//Create a new color mask
	show_debug_message("Main Camera says: No color surface");
	MAIN_CAMERA.color_mask = surface_create(render_width,render_height);
	//Clear it
	surface_set_target(MAIN_CAMERA.color_mask);
		draw_clear_alpha(c_white,0);
	surface_reset_target();
}

//Draw the outline mask
if (surface_exists(MAIN_CAMERA.outline_mask))
{
	if (draw_outline)
	{
		//Set the shader
		shader_set(outline_shader);
			//Set the uniforms to know what the size of one pixel is
			//Thanks to @Juju for the tip on texture_get_texel_width() & height
			shader_set_uniform_f(oneHorizontalUniform,texture_get_texel_width(surface_get_texture(MAIN_CAMERA.outline_mask)));
			shader_set_uniform_f(oneVerticalUniform,texture_get_texel_height(surface_get_texture(MAIN_CAMERA.outline_mask)));
			//Draw the outline mask
			draw_surface(MAIN_CAMERA.outline_mask,0,0);
		shader_reset();
		//Clear the outline mask
		surface_set_target(MAIN_CAMERA.outline_mask);
			draw_clear_alpha(c_white,0);
		surface_reset_target();
	}
	
	if (draw_debug)
	{
		draw_surface(MAIN_CAMERA.outline_mask,0,0);
	}
}
else
{
	//No outline mask! OH NO!
	show_debug_message("Main Camera says: No outline surface");
	//Creat a new outline mask and clear it
	MAIN_CAMERA.outline_mask = surface_create(render_width,render_height);
	surface_set_target(MAIN_CAMERA.outline_mask);
		draw_clear_alpha(c_white,0);
	surface_reset_target();
}

//Draw the fps
last_fps = lerp(last_fps,fps_real,.01);
draw_text_color(16,16,string(floor(last_fps)) + "\n" + string(floor(fps)) + "\n Use [space] to toggle the outline\nUse the arrow keys to move",c_red,c_red,c_red,c_red,1);
