/// @desc Draw Model

//Make sure both surfaces exist
if(surface_exists(MAIN_CAMERA.outline_mask))
{
	if (surface_exists(MAIN_CAMERA.color_mask))
	{
		//Disable blending so the alpha values don't change
		gpu_set_blendenable(false);
		//Set the toon shader
		shader_set(toon_shader)
			//Set the targets
			surface_set_target_ext(0, MAIN_CAMERA.color_mask);
			surface_set_target_ext(1, MAIN_CAMERA.outline_mask);
				//Reset the camera matrices
				camera_set_proj_mat(MAIN_CAMERA.camera, MAIN_CAMERA.projection_matrix);
				camera_set_view_mat(MAIN_CAMERA.camera, MAIN_CAMERA.view_matrix);
				//Apply the changes to the camera
				camera_apply(MAIN_CAMERA.camera);	
				//Disable the filtering for the ramp sampler
				gpu_set_tex_filter_ext(ramp_sampler,false);
				//Set the texture stage to the ramp
				texture_set_stage(ramp_sampler,sprite_get_texture(ramp_sprite,0));
				//Set the light direction to up
				shader_set_uniform_f(MAIN_CAMERA.lightDirectionUniform,0,0,-1);
				//Draw the model
				vertex_submit(my_model,pr_trianglelist,sprite_get_texture(model_sprite,0));
			//Reset the target
			surface_reset_target();
		//Reset the shader
		shader_reset();
		//Re-enable blending
		gpu_set_blendenable(true);
	}
	//Debug stuff to know when there's not a surface
	//The camera handles creating the surfaces
	else { show_debug_message("Model says: No color surface"); }
}
else { show_debug_message("Model says: No outline surface"); }