///@desc load_model(name)
///@param string name
///@returns model

//Script to load a model from the "Included Files"
//Thanks to: DragoniteSpam on Youtube
//https://www.youtube.com/user/2andaHalfStooges

var _result_model = vertex_create_buffer();
vertex_begin(_result_model,MODEL_VERTEX_FORMAT);

var _name = argument0;
var _file = file_text_open_read(_name);

var _vertex_x = ds_list_create();
var _vertex_y = ds_list_create();
var _vertex_z = ds_list_create();

var _normal_x = ds_list_create();
var _normal_y = ds_list_create();
var _normal_z = ds_list_create();

var _uv_x = ds_list_create();
var _uv_y = ds_list_create();

while (not file_text_eof(_file))
{
	var _line = file_text_readln(_file);
	var _tussles = ae_split(_line," ");
	
	switch(_tussles[0])
	{
		case "v": 
			ds_list_add(_vertex_x,real(_tussles[1]));
			ds_list_add(_vertex_y,real(_tussles[2]));
			ds_list_add(_vertex_z,real(_tussles[3]));
		break;
		
		case "vt": 
			ds_list_add(_uv_x,real(_tussles[1]));
			ds_list_add(_uv_y,real(_tussles[2]));
		break;
		
		case "vn": 
			ds_list_add(_normal_x,real(_tussles[1]));
			ds_list_add(_normal_y,real(_tussles[2]));
			ds_list_add(_normal_z,real(_tussles[3]));
		break;
		
		case "f":
			var ii = 1;
			repeat(array_length_1d(_tussles)-1)
			{
				var _data = ae_split(_tussles[ii],"/");
				
				var _x_vert = ds_list_find_value(_vertex_x,real(_data[0])-1);
				var _y_vert = ds_list_find_value(_vertex_y,real(_data[0])-1);
				var _z_vert = ds_list_find_value(_vertex_z,real(_data[0])-1);
				
				var _x_tex = ds_list_find_value(_uv_x,real(_data[1])-1);
				var _y_tex = ds_list_find_value(_uv_y,real(_data[1])-1);
				
				var _x_norm = ds_list_find_value(_normal_x,real(_data[2])-1);
				var _y_norm = ds_list_find_value(_normal_y,real(_data[2])-1);
				var _z_norm = ds_list_find_value(_normal_z,real(_data[2])-1);
				
				vertex_position_3d(_result_model,_x_vert,_y_vert,_z_vert);
				//Flip the y coordinate
				vertex_texcoord(_result_model,_x_tex,1-_y_tex);
				vertex_normal(_result_model,_x_norm,_y_norm,_z_norm);
				vertex_color(_result_model,c_white,1);
				
				ii+=1;
			}
		
	}
}

ds_list_destroy(_vertex_x);
ds_list_destroy(_vertex_y);
ds_list_destroy(_vertex_z);
ds_list_destroy(_uv_x);
ds_list_destroy(_uv_y);
ds_list_destroy(_normal_x);
ds_list_destroy(_normal_y);
ds_list_destroy(_normal_z);

file_text_close(_file);
vertex_end(_result_model);
return _result_model;