//Standard HLSL vertex shader
struct VertexShaderInput
{
    float4 vPosition : POSITION;
	float2 vTexcoord : TEXCOORD0;
	float4 vColor    : COLOR;
};

struct VertexShaderOutput
{
    float4 vPosition : SV_POSITION;
    float4 vColor    : COLOR;
    float2 vTexcoord : TEXCOORD;
};

VertexShaderOutput main(VertexShaderInput INPUT)
{
    VertexShaderOutput OUTPUT;

	float4 matrixWVP = mul(gm_Matrices[MATRIX_WORLD_VIEW_PROJECTION], INPUT.vPosition);

    OUTPUT.vPosition = matrixWVP;
    OUTPUT.vColor    = INPUT.vColor;
    OUTPUT.vTexcoord = INPUT.vTexcoord;

    return OUTPUT;
} 