//Base GLSL ES vertex shader with a few modifications

//The input
attribute vec4 vPosition;
attribute vec2 vTexcoord;
attribute vec4 vNormal;
attribute vec4 vColor;

//The output is important to note
//This is the information that will be passed into the fragment shader
varying vec4 o_vPosition;
varying vec4 o_vColor;
varying vec2 o_vTexcoord;
//Pass in the normals
varying vec4 o_vNormal;
//Pass in the camera direction (as a normal)
varying vec4 o_vCamera;
//Pass in the depth of the vertex
varying float o_vDepth;

void main()
{

	//Set the camera to the proper direction
	o_vCamera = -vec4(gm_Matrices[MATRIX_WORLD_VIEW][2][0],
						gm_Matrices[MATRIX_WORLD_VIEW][2][1],
						gm_Matrices[MATRIX_WORLD_VIEW][2][2],
						gm_Matrices[MATRIX_WORLD_VIEW][2][3]);

	//Build the world view projection
    vec4 matrixWVP = gm_Matrices[MATRIX_WORLD_VIEW_PROJECTION] * vPosition;
	
	//Get the depth as a value between 0 and 1
	o_vDepth = matrixWVP.z / matrixWVP.w;
	//Pass in the rest of the values
    o_vPosition = matrixWVP;
    o_vColor    = vColor;
    o_vTexcoord = vTexcoord;
    o_vNormal = vNormal;
}